library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity dts_signals is
    Port (
        clk_in : in  STD_LOGIC;
		  btn0 : in  STD_LOGIC;
		  A0   : out  STD_LOGIC;
		  A0_N : out  STD_LOGIC;
		  A1   : out  STD_LOGIC;
		  A1_N : out  STD_LOGIC		  
    );
end dts_signals;

architecture Behavioral of dts_signals is
    signal c_TTL	   : integer range 0 to 81910 := 0; -- 2^13	reset after 10 cycle
    signal position	: integer range 0 to 8191 := 0; -- 2^13
	 signal A0_M  		: std_logic := '0';
	 signal A1_M  		: std_logic := '0';
	 signal btn0_M		: std_logic := '0';
	 signal c_TTL_M	: std_logic := '0';
begin
    dts_signals: process (clk_in) begin
		  if rising_edge(clk_in) then		  
					if (btn0 = '1' and btn0_M = '0' and position < 5000)	then
						position <= (position + 200);
						btn0_M <= '1';	
					end if;
					if (btn0 = '0' and btn0_M = '1') 							then 		
						btn0_M <= '0';	
					end if;
				
					if c_TTL = 60000 then
						c_TTL <= 0;
						c_TTL_M<='0';
						if position > 2000 then
							if (A0_M='0' and A1_M='0' and c_TTL_M='0') then A1_M<='1';c_TTL_M<='1'; end if;
							if (A0_M='0' and A1_M='1' and c_TTL_M='0') then A0_M<='1';c_TTL_M<='1'; end if;
							if (A0_M='1' and A1_M='0' and c_TTL_M='0') then A0_M<='0';c_TTL_M<='1'; end if;
							if (A0_M='1' and A1_M='1' and c_TTL_M='0') then A1_M<='0';c_TTL_M<='1'; end if;	
							if (A0_M = '1') then A0_N<='0';A0<='1'; else A0_N<='1';A0<='0';end if;
							if (A1_M = '1') then A1_N<='0';A1<='1'; else A1_N<='1';A1<='0';end if;
							position <= (position - 1);
						end if;
					else
						c_TTL <= c_TTL + 1;
					end if;
        end if;
    end process;
end Behavioral;